PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Types | Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | List of all members
PSMTPServer Class Reference

A TCP/IP socket for the Simple Mail Transfer Protocol. More...

`#include <inetmail.h>`

Inheritance diagram for PSMTPServer:
[legend]
Collaboration diagram for PSMTPServer:
[legend]

## Public Types
enum | ForwardResult { LocalDomain, WillForward, CannotForward }
enum | LookUpResult { ValidUser, AmbiguousUser, UnknownUser, LookUpError }
Public Types inherited from PSMTP
enum | Commands { HELO, EHLO, QUIT, HELP, NOOP, TURN, RSET, VRFY, EXPN, RCPT, MAIL, SEND, SAML, SOML, DATA, AUTH, NumCommands }

## Public Member Functions
| PSMTPServer ()
| Create a TCP/IP SMPTP protocol socket channel. More...
PBoolean | ProcessCommand ()
| Process commands, dispatching to the appropriate virtual function. More...
void | ServerReset ()
virtual ForwardResult | ForwardDomain (PCaselessString &userDomain, PCaselessString &forwardDomainList)
| Determine if a user for this domain may be on the local system, or should be forwarded. More...
virtual LookUpResult | LookUpName (const PCaselessString &name, PString &expandedName)
| Look up a name in the context of the SMTP server. More...
virtual PBoolean | HandleMessage (PCharArray &buffer, PBoolean starting, PBoolean completed)
| Handle a received message. More...

## Protected Types
enum | { WasMAIL, WasSEND, WasSAML, WasSOML }

## Protected Member Functions
PBoolean | OnOpen ()
| This callback is executed when the Open() function is called with open channels. More...
virtual void | OnHELO (const PCaselessString &remoteHost)
virtual void | OnEHLO (const PCaselessString &remoteHost)
virtual void | OnQUIT ()
virtual void | OnHELP ()
virtual void | OnNOOP ()
virtual void | OnTURN ()
virtual void | OnRSET ()
virtual void | OnVRFY (const PCaselessString &name)
virtual void | OnEXPN (const PCaselessString &name)
virtual void | OnRCPT (const PCaselessString &recipient)
virtual void | OnMAIL (const PCaselessString &sender)
virtual void | OnSEND (const PCaselessString &sender)
virtual void | OnSAML (const PCaselessString &sender)
virtual void | OnSOML (const PCaselessString &sender)
virtual void | OnDATA ()
virtual PBoolean | OnUnknown (const PCaselessString &command)
| Handle an unknown command. More...
virtual void | OnSendMail (const PCaselessString &sender)
virtual PBoolean | OnTextData (PCharArray &buffer, PBoolean &completed)
| Read a standard text message that is being received by the socket. More...
virtual PBoolean | OnMIMEData (PCharArray &buffer, PBoolean &completed)
| Read an eight bit MIME message that is being received by the socket. More...
Protected Member Functions inherited from PSMTP
| PSMTP ()
Protected Member Functions inherited from PInternetProtocol
| PInternetProtocol (const char *defaultServiceName, PINDEX cmdCount, char const *const *cmdNames)
virtual PINDEX | ParseResponse (const PString &line)
| Parse a response line string into a response code and any extra info on the line. More...

## Protected Attributes
PBoolean | extendedHello
PBoolean | eightBitMIME
PString | fromAddress
PString | fromPath
PStringList | toNames
PStringList | toDomains
PINDEX | messageBufferSize
enum PSMTPServer:: { ... } | sendCommand
StuffState | endMIMEDetectState

## Additional Inherited Members
Static Public Member Functions inherited from PChannel
static PString | GetErrorText (Errors lastError, int osError=0)
| Get error message description. More...
static PBoolean | ConvertOSError (P_INT_PTR libcReturnValue, Errors &lastError, int &osError)
| Convert an operating system error into platform independent error. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Friends inherited from PObject

## Detailed Description

A TCP/IP socket for the Simple Mail Transfer Protocol.

When acting as a client, the procedure is to make the connection to a remote server, then to send a message using the following procedure: `PSMTPSocket mail("mailserver"); if (mail.IsOpen()) { mail.BeginMessage("Me@here.com.au", "Fred@somwhere.com"); mail.Write(myMessage); if (!mail.EndMessage()) PError << "Mail send failed." << endl; } else PError << "Mail conection failed." << endl;`

When acting as a server, a descendant class would be created to override at least the LookUpName() and HandleMessage() functions. Other functions may be overridden for further enhancement to the sockets capabilities, but these two will give a basic SMTP server functionality.

The server socket thread would continuously call the ProcessMessage() function until it returns false. This will then call the appropriate virtual function on parsing the SMTP protocol.

## Member Enumeration Documentation

anonymous enum
| protected

Enumerator
WasMAIL |
WasSEND |
WasSAML |
WasSOML |

enum PSMTPServer::ForwardResult

Enumerator
LocalDomain | User may be on local machine, do LookUpName().
WillForward | User may be forwarded to another SMTP host.
CannotForward | User cannot be forwarded.

enum PSMTPServer::LookUpResult

Enumerator
ValidUser | User name was valid and unique.
AmbiguousUser | User name was valid but ambiguous.
UnknownUser | User name was invalid.
LookUpError | Some other error occurred in look up.

## Constructor & Destructor Documentation

PSMTPServer::PSMTPServer | ( |  | ) |

Create a TCP/IP SMPTP protocol socket channel.

The parameterless form creates an unopened socket, the form with the `address` parameter makes a connection to a remote system, opening the socket. The form with the `socket` parameter opens the socket to an incoming call from a "listening" socket.

## Member Function Documentation

virtual ForwardResult PSMTPServer::ForwardDomain | ( | PCaselessString & | userDomain,
|  | PCaselessString & | forwardDomainList
| ) |  |
| virtual

Determine if a user for this domain may be on the local system, or should be forwarded.

Returns
  Result of forward check operation.

Parameters

  userDomain | Domain for user
  forwardDomainList | Domains forwarding to

virtual PBoolean PSMTPServer::HandleMessage | ( | PCharArray & | buffer,
|  | PBoolean | starting,
|  | PBoolean | completed
| ) |  |
| virtual

Handle a received message.

The `buffer` parameter contains the partial or complete message received, depending on the `completed` parameter.

The default behaviour is to simply return false;

Returns
  true if message was handled, false if an error occurs.

Parameters

  buffer | Buffer containing message data received.
  starting | This is the first call for the message.
  completed | This is the last call for the message. Indication that the entire message has been received.

virtual LookUpResult PSMTPServer::LookUpName | ( | const PCaselessString & | name,
|  | PString & | expandedName
| ) |  |
| virtual

Look up a name in the context of the SMTP server.

The default bahaviour simply returns false.

Returns
  Result of name look up operation.

Parameters

  name | Name to look up.
  expandedName | Expanded form of name (if found).

virtual void PSMTPServer::OnDATA | ( |  | ) |
| protected virtual

virtual void PSMTPServer::OnEHLO | ( | const PCaselessString & | remoteHost | ) |
| protected virtual

Parameters

  remoteHost | Name of remote host.

virtual void PSMTPServer::OnEXPN | ( | const PCaselessString & | name | ) |
| protected virtual

Parameters

  name | Name to expand.

virtual void PSMTPServer::OnHELO | ( | const PCaselessString & | remoteHost | ) |
| protected virtual

Parameters

  remoteHost | Name of remote host.

virtual void PSMTPServer::OnHELP | ( |  | ) |
| protected virtual

virtual void PSMTPServer::OnMAIL | ( | const PCaselessString & | sender | ) |
| protected virtual

Parameters

  sender | Name of sender.

virtual PBoolean PSMTPServer::OnMIMEData | ( | PCharArray & | buffer,
|  | PBoolean & | completed
| ) |  |
| protected virtual

Read an eight bit MIME message that is being received by the socket.

The MIME message is terminated by the CR/LF/./CR/LF sequence.

The default behaviour is to read the data into the `buffer` parameter until either the end of the message or when the `messageBufferSize` bytes have been read.

Returns
  true if partial message received, false if the end of the data was received.

virtual void PSMTPServer::OnNOOP | ( |  | ) |
| protected virtual

PBoolean PSMTPServer::OnOpen | ( |  | ) |
| protected virtual

This callback is executed when the Open() function is called with open channels.

It may be used by descendent channels to do any handshaking required by the protocol that channel embodies.

The default behaviour is to simply return true.

Returns
  Returns true if the protocol handshaking is successful.

Reimplemented from PIndirectChannel.

virtual void PSMTPServer::OnQUIT | ( |  | ) |
| protected virtual

virtual void PSMTPServer::OnRCPT | ( | const PCaselessString & | recipient | ) |
| protected virtual

Parameters

  recipient | Name of recipient.

virtual void PSMTPServer::OnRSET | ( |  | ) |
| protected virtual

virtual void PSMTPServer::OnSAML | ( | const PCaselessString & | sender | ) |
| protected virtual

Parameters

  sender | Name of sender.

virtual void PSMTPServer::OnSEND | ( | const PCaselessString & | sender | ) |
| protected virtual

Parameters

  sender | Name of sender.

virtual void PSMTPServer::OnSendMail | ( | const PCaselessString & | sender | ) |
| protected virtual

Parameters

  sender | Name of sender.

virtual void PSMTPServer::OnSOML | ( | const PCaselessString & | sender | ) |
| protected virtual

Parameters

  sender | Name of sender.

virtual PBoolean PSMTPServer::OnTextData | ( | PCharArray & | buffer,
|  | PBoolean & | completed
| ) |  |
| protected virtual

Read a standard text message that is being received by the socket.

The text message is terminated by a line with a '.' character alone.

The default behaviour is to read the data into the `buffer` parameter until either the end of the message or when the `messageBufferSize` bytes have been read.

Returns
  true if partial message received, false if the end of the data was received.

virtual void PSMTPServer::OnTURN | ( |  | ) |
| protected virtual

virtual PBoolean PSMTPServer::OnUnknown | ( | const PCaselessString & | command | ) |
| protected virtual

Handle an unknown command.

Returns
  true if more processing may be done, false if the ProcessCommand() function is to return false.

Parameters

  command | Complete command line received.

virtual void PSMTPServer::OnVRFY | ( | const PCaselessString & | name | ) |
| protected virtual

Parameters

  name | Name to verify.

PBoolean PSMTPServer::ProcessCommand | ( |  | ) |

Process commands, dispatching to the appropriate virtual function.

This is used when the socket is acting as a server.

Returns
  true if more processing may be done, false if the QUIT command was received or the OnUnknown() function returns false.

void PSMTPServer::ServerReset | ( |  | ) |

## Member Data Documentation

PBoolean PSMTPServer::eightBitMIME
| protected

StuffState PSMTPServer::endMIMEDetectState
| protected

PBoolean PSMTPServer::extendedHello
| protected

PString PSMTPServer::fromAddress
| protected

PString PSMTPServer::fromPath
| protected

PINDEX PSMTPServer::messageBufferSize
| protected

enum { ... } PSMTPServer::sendCommand

PStringList PSMTPServer::toDomains
| protected

PStringList PSMTPServer::toNames
| protected

The documentation for this class was generated from the following file:

- inetmail.h